#include "dir.h"


//---------------------------------------------------------------------------
ST_DIR Dir;


//---------------------------------------------------------------------------
EWRAM_CODE u16 DirChrGetVec(s16 mx, s16 my)
{
	if(mx ==  0 && my ==  1) return VEC_DOWN;
	if(mx ==  0 && my == -1) return VEC_UP;
	if(mx == -1 && my ==  0) return VEC_LEFT;
	if(mx ==  1 && my ==  0) return VEC_RIGHT;

	if(mx == -1 && my == -1) return VEC_UP_LEFT;
	if(mx ==  1 && my == -1) return VEC_UP_RIGHT;
	if(mx == -1 && my ==  1) return VEC_DOWN_LEFT;
	if(mx ==  1 && my ==  1) return VEC_DOWN_RIGHT;

	return VEC_DOWN;
}
//---------------------------------------------------------------------------
EWRAM_CODE u16 DirChrGetPat(ST_DIR_CHR* p)
{
	u16 ret = p->pat * 48;

	switch(p->vec)
	{
	case VEC_DOWN:
	case VEC_DOWN_LEFT:
	case VEC_DOWN_RIGHT:
		ret += 0;
		break;

	case VEC_UP:
	case VEC_UP_LEFT:
	case VEC_UP_RIGHT:
		ret += 12;
		break;

	case VEC_LEFT:
		ret += 24;
		break;

	case VEC_RIGHT:
		ret += 36;
		break;

	default:
		SystemError("[Err] DirChrGetPat\n");
		break;
	}

	ret += Dir.seq * 2;

	return ret;
}
//---------------------------------------------------------------------------
EWRAM_CODE void DirInit()
{
	_Memset((u8*)&Dir, 0x00, sizeof(ST_DIR));
}
//---------------------------------------------------------------------------
EWRAM_CODE void DirExec()
{
	ST_DIR* p = &Dir;

	if(p->tick++ <= DIR_MAX_TICK_CNT)
	{
		return;
	}
	p->tick = 0;

	if(++p->seq >= 3)
	{
		p->seq = 0;
	}
}
