#ifndef __DUN_H__
#define __DUN_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"
#include "item.h"

//---------------------------------------------------------------------------
#define PART_MAX_CNT	30
#define RECT_W(r)		((r).right-(r).left)		// RECT ̕vZ
#define RECT_H(r)		((r).bottom-(r).top)		// RECT ̍vZ
#define DUN_CX			30
#define DUN_CY			20

#define TILE_BLACK		0
#define TILE_EARTH		4
#define TILE_WALL		8
#define TILE_EARTH_STEP	12
#define TILE_BLACK_STEP	16
#define TILE_TRAP		20
#define TILE_ITEM		24
#define TILE_WALL_UP	28


// _W̎
enum {
	DUN_ID_NONE = 0x00,
	DUN_ID_CONST,
	DUN_ID_RAND1,
	DUN_ID_RAND2,
	DUN_ID_RAND3,
};

// 㩂̎
enum {
	TRAP_ID_NONE = 0x00,
	TRAP_ID_DAMAGE,
	TRAP_ID_POISON,
	TRAP_ID_MAX,
};

//---------------------------------------------------------------------------

typedef struct {
	s16 left;
	s16 top;
	s16 right;
	s16 bottom;
} ST_RECT;


typedef struct {
	ST_RECT rect;					// ͈
	ST_RECT room;					// ͈
} ST_PART;


typedef struct {
	bool isWall;
	bool isStepUp;
	bool isStepDown;
	bool isMiniMap;
	bool isTrapShow;
	u8   trapId;
	ST_ITEM item;
} ST_TILE ALIGN(4);


typedef struct {
	u16 id;
	s16 cx;							// _W̑傫
	s16 cy;
	s16 turnCnt;
	s16 stepUpX;					// Ki
	s16 stepUpY;
	s16 stepDownX;
	s16 stepDownY;

	s16 partCnt;					// ̐
	ST_PART part[PART_MAX_CNT];

	ST_TILE* pTile;					// 
	u32 tileSize;					// ^C̊mۂoCg
} ST_DUN;


//---------------------------------------------------------------------------
EWRAM_CODE void DunInit();
EWRAM_CODE bool DunLoad();
EWRAM_CODE void DunSave();
EWRAM_CODE void DunDraw();
EWRAM_CODE void DunMake(s16 floorCnt);
EWRAM_CODE void DunTurn(s16 floorCnt);

EWRAM_CODE void DunCallocTile(s16 cx, s16 cy);
EWRAM_CODE void DunFreeTile();


//----
EWRAM_CODE void DunSetMiniMap(s16 nx, s16 ny);
EWRAM_CODE void DunSetMiniMapWay(s16 nx, s16 ny);
EWRAM_CODE void DunSetMiniMapRoom(s16 idx);

EWRAM_CODE s16  DunGetCx();
EWRAM_CODE s16  DunGetCy();
EWRAM_CODE s16  DunGetRoomIdx(s16 x, s16 y);
EWRAM_CODE s16  DunGetRectIdx(s16 x, s16 y);
EWRAM_CODE s16  DunGetPartCnt();
EWRAM_CODE u16  DunGetTileNo(s16 x, s16 y);
EWRAM_CODE ST_TILE* DunGetTile(s16 x, s16 y);
EWRAM_CODE ST_RECT* DunGetRoom(s16 idx);


EWRAM_CODE void DunDebug();


#ifdef __cplusplus
}
#endif
#endif
