#include "dunconst.h"
#include "mob.h"
#include "lex.h"
#include "dir.h"


//---------------------------------------------------------------------------
// dun.c
extern ST_DUN Dun;


//---------------------------------------------------------------------------
EWRAM_CODE void DunConstMake(char* pStr)
{
	u16 fd = LexOpen(pStr);

	// _W̑傫擾܂
	s32 cx = LexGetSafeNum(fd);
	s32 cy = LexGetSafeNum(fd);
	DunCallocTile(cx, cy);

	// [map]^OɈړ܂
	if(LexSeekTag(fd, "[map]") == FALSE)
	{
		goto Err;
	}
	LexNextLine(fd);

	// }bveLXg^Cɓǂݍ݂܂
	s32 x, y;
	char chr;

	for(y=0; y<cy; y++)
	{
		for(x=0; x<cx; x++)
		{
			if(LexIsEnd(fd) == TRUE)
			{
				goto Err;
			}
			chr = LexGetSafeChr(fd);


			ST_TILE* p = DunGetTile(x, y);

			switch(chr)
			{
			// 
			case '.':
				p->isMiniMap  = TRUE;
				break;

			// 
			case '#':
				p->isMiniMap  = FALSE;
				p->isWall     = TRUE;
				break;

			// Ki
			case '<':
				p->isMiniMap  = TRUE;
				p->isStepUp   = TRUE;
				Dun.stepUpX   = x;
				Dun.stepUpY   = y;
				break;

			// Ki
			case '>':
				p->isMiniMap  = TRUE;
				p->isStepDown = TRUE;
				Dun.stepDownX = x;
				Dun.stepDownY = y;
				break;

			// ̂ق
			default:
				p->isMiniMap  = TRUE;

				if(DunConstSetObj(pStr, p, x, y, chr) == FALSE)
				{
					goto Err;
				}
				break;
			}
		}
	}

	LexClose(fd);
	return;

Err:
	SystemError("[Err] DunConstMake");
}
//---------------------------------------------------------------------------
EWRAM_CODE bool DunConstSetObj(char* pStr, ST_TILE* pT, u16 x, u16 y, char key)
{
	u16  fd = LexOpen(pStr);
	char chr;

	// [param]^OɈړ܂
	if(LexSeekTag(fd, "[param]") == FALSE)
	{
		goto Err;
	}

	// TĂL[܂
	do {
		LexNextLine(fd);
		chr = LexGetChrNoSeek(fd);

		if((LexIsEnd(fd) == TRUE) || (chr == '['))
		{
			goto Err;
		}

	} while(chr != key);


	// ʂ߂܂
	char id = LexGetSafeChr(fd);
	s16  trapId;

	switch(id)
	{
	// X^[
	case 'm':
		if(MobIsMaxCnt() == TRUE)
		{
			goto Err;
		}

		ST_MOB_CHR* pMob = MobMake();

		_Strncpy(pMob->name, LexGetSafeStr(fd), MAX_MOB_NAME_CNT);
		pMob->ai               = LexGetSafeNum(fd);
		pMob->exp              = LexGetSafeNum(fd);
		pMob->agi              = LexGetSafeNum(fd);
		pMob->atk              = LexGetSafeNum(fd);
		pMob->def              = LexGetSafeNum(fd);
		pMob->speed            = LexGetSafeNum(fd);
		pMob->hp               = LexGetSafeNum(fd);
		pMob->dir.pat          = LexGetSafeNum(fd);		// graphic
		pMob->dropItemID       = LexGetSafeNum(fd);
		pMob->dropPercent      = LexGetSafeNum(fd);
		pMob->dropUnidentified = LexGetSafeNum(fd);

		pMob->isUnidentified   = ((s16)_Rand(100) < pMob->dropUnidentified) ? TRUE : FALSE;
		pMob->x                = x;
		pMob->y                = y;
		pMob->tickCnt          = pMob->speed;
		pMob->maxHp            = pMob->maxHp;
		pMob->dir.vec          = VEC_DOWN;

		break;

	// 
	case 't':
		trapId = LexGetSafeNum(fd);

		if(trapId > TRAP_ID_NONE && trapId < TRAP_ID_MAX)
		{
			pT->trapId = trapId;
		}
		else
		{
			goto Err;
		}
		break;

	// ACe
	case 'i':
		pT->item.id = LexGetSafeNum(fd);

		_Strncpy(pT->item.name, LexGetSafeStr(fd), ITEM_MAX_NAME_CNT);
		_Strncpy(pT->item.unName, LexGetSafeStr(fd), ITEM_MAX_NAME_CNT);

		pT->item.isUnidentified = (LexGetSafeNum(fd) > (s16)_Rand(100)) ? TRUE : FALSE;

		s16 i;
		for(i=0; i<ITEM_MAX_PARAM_CNT; i++)
		{
			pT->item.param[i] = LexGetSafeNum(fd);
		}
		break;

	// ȊO
	default:
		goto Err;
		break;

	} // switch(id)

	LexClose(fd);
	return TRUE;

Err:
	LexClose(fd);
	return FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void DunConstTurn(s16 floorCnt)
{
	// EMPTY
}
