#include "dunrand1.h"
#include "mob.h"
#include "hero.h"

//---------------------------------------------------------------------------
// dun.c
extern ST_DUN Dun;


//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1Init(s16 cx, s16 cy)
{
	DunCallocTile(cx, cy);

	s16 x, y;

	for(y=0; y<Dun.cy; y++)
	{
		for(x=0; x<Dun.cx; x++)
		{
			ST_TILE* p = DunGetTile(x, y);
			p->isWall = TRUE;
		}
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1Make(s16 cx, s16 cy, s16 floorCnt)
{
	DunRand1Init(cx, cy);

	// 
	DunRand1PartMake(0, 0, Dun.cx-1, Dun.cy-1);
	DunRand1PartSplit((_Rand(2) == 0) ? TRUE : FALSE);

	// 
	DunRand1RoomMake();
	DunRand1RoomConnect();

	// 
	DunRand1MobMake(floorCnt);
}
//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1Turn(s16 floorCnt)
{
	Dun.turnCnt++;

	// l20sƂɃX^[𕦂
	if(DivMod(Dun.turnCnt, 20) == 0)
	{
		DunRand1MobMakeRand(floorCnt);
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE ST_PART* DunRand1PartMake(s16 left, s16 top, s16 right, s16 bottom)
{
	ST_PART* p = &Dun.part[Dun.partCnt];
	Dun.partCnt++;

	_Memset(p, 0x00, sizeof(ST_RECT));

	p->rect.left   = left;
	p->rect.top    = top;
	p->rect.right  = right;
	p->rect.bottom = bottom;

	return p;
}
//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1PartSplit(bool isVert)
{
	ST_RECT* pRect   = &Dun.part[Dun.partCnt-1].rect;
	ST_PART* pParent = &Dun.part[Dun.partCnt-1];
	ST_PART* pChild;

	// cɕ܂
	if(isVert == FALSE)
	{
		if(RECT_W(*pRect) < (DUN_RAND1_MIN_ROOM_SIZE+3)*2+1)
		{
			return;
		}

		s16 a  = DUN_RAND1_MIN_ROOM_SIZE + 3;
		s16 b  = RECT_W(*pRect) - DUN_RAND1_MIN_ROOM_SIZE - 4;
		s16 ab = b - a;
		s16 p  = a + _Rand(ab+1);

		pChild = DunRand1PartMake(pRect->left + p, pRect->top, pRect->right, pRect->bottom);

		// ̋̉E p n_ɈړāA̋Ƃ܂
		pParent->rect.right = pChild->rect.left;
	}
	else
	{
		if(RECT_H(*pRect) < (DUN_RAND1_MIN_ROOM_SIZE+3)*2+1)
		{
			return;
		}

		s16 a  = DUN_RAND1_MIN_ROOM_SIZE + 3;
		s16 b  = RECT_H(*pRect) - DUN_RAND1_MIN_ROOM_SIZE - 4;
		s16 ab = b - a;
		s16 p  = a + _Rand(ab+1);

		pChild = DunRand1PartMake(pRect->left, pRect->top + p, pRect->right, pRect->bottom);

		// ̋̉ p n_ɈړāA㑤̋Ƃ܂
		pParent->rect.bottom = pChild->rect.top;
	}

	// ̕_Ō肷邽߂ɓւ܂
	if(_Rand(2) == 0)
	{
		ST_PART dunRect;

		_Memcpy(&dunRect, pChild, sizeof(ST_PART));
		_Memcpy(pChild, pParent, sizeof(ST_PART));
		_Memcpy(pParent, &dunRect, sizeof(ST_PART));
	}

	// q̕ɕ܂
	DunRand1PartSplit(!isVert);
}
//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1RoomMake()
{
	s16 w, h, cw, ch, sw, sh, rw, rh, rx ,ry;
	s16 i;

	for(i=0; i<Dun.partCnt; i++)
	{
		ST_RECT* pRect = &Dun.part[i].rect;
		ST_RECT* pRoom = &Dun.part[i].room;

		// `̑傫vZ
		w = RECT_W(*pRect) - 3;
		h = RECT_H(*pRect) - 3;

		// ɓŏ̗]T߂܂
		cw = w - DUN_RAND1_MIN_ROOM_SIZE;
		ch = h - DUN_RAND1_MIN_ROOM_SIZE;

		// ̑傫肵܂
		sw = _Rand(cw);
		sh = _Rand(ch);
		rw = w - sw;
		rh = h - sh;

		// ̈ʒu肵܂
		rx = _Rand(sw) + 2;
		ry = _Rand(sh) + 2;

		// ߂ʂ畔̏ݒ
		pRoom->left   = pRect->left + rx;
		pRoom->top    = pRect->top  + ry;
		pRoom->right  = pRoom->left + rw;
		pRoom->bottom = pRoom->top  + rh;

		// ܂
		DunRand1FillRect(pRoom->left, pRoom->top, pRoom->right, pRoom->bottom, FALSE);

		if(i == 0)
		{
			// Kizu
			ST_RECT* pRoom2 = &Dun.part[i].room;

			Dun.stepUpX = pRoom->left + _Rand(RECT_W(*pRoom2));
			Dun.stepUpY = pRoom->top  + _Rand(RECT_H(*pRoom2));

			ST_TILE* pTile = DunGetTile(Dun.stepUpX, Dun.stepUpY);
			pTile->isStepUp = TRUE;
		}
		else if(i == Dun.partCnt-1)
		{
			// Kizu
			ST_RECT* pRoom2 = &Dun.part[i].room;

			Dun.stepDownX = pRoom->left + _Rand(RECT_W(*pRoom2));
			Dun.stepDownY = pRoom->top  + _Rand(RECT_H(*pRoom2));

			ST_TILE* pTile = DunGetTile(Dun.stepDownX, Dun.stepDownY);
			pTile->isStepDown = TRUE;
		}
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1RoomConnect()
{
	s16 i;

	for(i=0; i<Dun.partCnt-1; i++)
	{
		DunRand1RoadMake(i, i+1);
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 DunRand1RoomRandX(s16 idx)
{
	ST_RECT* pRoom = &Dun.part[idx].room;

	return pRoom->left + _Rand(RECT_W(*pRoom));
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 DunRand1RoomRandY(s16 idx)
{
	ST_RECT* pRoom = &Dun.part[idx].room;

	return pRoom->top + _Rand(RECT_H(*pRoom));
}
//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1RoadMake(s16 roomA, s16 roomB)
{
	ST_RECT* pRectA = &Dun.part[roomA].rect;
	ST_RECT* pRectB = &Dun.part[roomB].rect;
	ST_RECT* pRoomA = &Dun.part[roomA].room;
	ST_RECT* pRoomB = &Dun.part[roomB].room;

	if(pRectA->bottom == pRectB->top || pRectA->top == pRectB->bottom)
	{
		// ㉺ŌqĂ

		s16 x1 = _Rand(RECT_W(*pRoomA)) + pRoomA->left;
		s16 x2 = _Rand(RECT_W(*pRoomB)) + pRoomB->left;
		s16 y;

		if(pRectA->top > pRectB->top)
		{
			// B
			// A
			y = pRectA->top;
			DunRand1FillRect(x1, y+1, x1+1, pRoomA->top, FALSE);
			DunRand1FillRect(x2, pRoomB->bottom, x2+1, y, FALSE);
		}
		else
		{
			// A
			// B
			y = pRectB->top;
			DunRand1FillRect(x1, pRoomA->bottom, x1+1, y, FALSE);
			DunRand1FillRect(x2, y, x2+1, pRoomB->top, FALSE);
		}

		DunRand1FillHLine(x1, x2, y, FALSE);
	}
	else if(pRectA->right == pRectB->left || pRectA->left == pRectB->right)
	{
		// EōEŌqĂ

		s16 y1 = _Rand(pRoomA->bottom-pRoomA->top) + pRoomA->top;
		s16 y2 = _Rand(pRoomB->bottom-pRoomB->top) + pRoomB->top;
		s16 x;

		if(pRectA->left > pRectB->left)
		{
			// BA
			x = pRectA->left;
			DunRand1FillRect( pRoomB->right, y2, x, y2+1, FALSE);
			DunRand1FillRect( x+1, y1, pRoomA->left, y1+1, FALSE);
		}
		else
		{
			// AB
			x = pRectB->left;
			DunRand1FillRect(pRoomA->right, y1, x, y1+1, FALSE);
			DunRand1FillRect(x, y2, pRoomB->left, y2+1, FALSE);
		}

		DunRand1FillVLine(y1, y2, x, FALSE);
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1MobMake(s16 floorCnt)
{
	s16 x, y;
	s16 i;

	// ꂼ̕ɂP̔zu܂B0Ԗڂ̓vC镔Ȃ̂ŔzuȂ
	for(i=1; i<Dun.partCnt; i++)
	{
		if(MobIsMaxCnt() == FALSE)
		{
			x = DunRand1RoomRandX(i);
			y = DunRand1RoomRandY(i);
			MobMakeRnd(x, y, floorCnt);
		}

		if(_Rand(3) == 0)
		{
			x = DunRand1RoomRandX(i);
			y = DunRand1RoomRandY(i);

			ST_TILE* pTile = DunGetTile(x, y);
			pTile->trapId = (_Rand(TRAP_ID_MAX-1) + 1);
		}
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1MobMakeRand(s16 floorCnt)
{
	if(MobIsMaxCnt() == TRUE)
	{
		return;
	}

	s16 hx      = HeroGetX();
	s16 hy      = HeroGetY();
	s16 HeroIdx = DunGetRoomIdx(hx, hy);
	s16 i;

	// 10قǔzus܂
	for(i=0; i<10; i++)
	{
		s16 roomIdx = _Rand(Dun.partCnt);

		if(roomIdx == HeroIdx)
		{
			continue;
		}

		s16 x = DunRand1RoomRandX(roomIdx);
		s16 y = DunRand1RoomRandY(roomIdx);

		if(MobGetChr(x, y) != NULL)
		{
			continue;
		}

		MobMakeRnd(x, y, floorCnt);
		return;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1FillRect(s16 left, s16 top, s16 right, s16 bottom, bool isWall)
{
	s16 x, y;
	s16 tmp;

	if(left > right)
	{
		tmp   = left;
		left  = right;
		right = tmp;
	}

	if(top > bottom)
	{
		tmp    = top;
		top    = bottom;
		bottom = tmp;
	}

	for(y=top; y<bottom; y++)
	{
		for(x=left; x<right; x++)
		{
			ST_TILE* p = DunGetTile(x, y);
			p->isWall = isWall;
		}
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1FillHLine(s16 left, s16 right, s16 y, bool isWall)
{
	s16 x;
	s16 tmp;

	if(left > right)
	{
		tmp   = left;
		left  = right;
		right = tmp;
	}

	for(x=left; x<=right; x++)
	{
		ST_TILE* p = DunGetTile(x, y);
		p->isWall = isWall;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1FillVLine(s16 top, s16 bottom, s16 x, bool isWall)
{
	s16 y;
	s16 tmp;

	if(top > bottom)
	{
		tmp    = top;
		top    = bottom;
		bottom = tmp;
	}

	for(y=top; y<=bottom; y++)
	{
		ST_TILE* p = DunGetTile(x, y);
		p->isWall = isWall;
	}
}