#ifndef __DUN_RAND1_H__
#define __DUN_RAND1_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "lib/gba.h"
#include "dun.h"

//---------------------------------------------------------------------------
#define DUN_RAND1_MIN_ROOM_SIZE		4


//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
EWRAM_CODE void DunRand1Init(s16 cx, s16 cy);
EWRAM_CODE void DunRand1Make(s16 cx, s16 cy, s16 floorCnt);
EWRAM_CODE void DunRand1Turn(s16 floorCnt);


//----
EWRAM_CODE ST_PART* DunRand1PartMake(s16 left, s16 top, s16 right, s16 bottom);
EWRAM_CODE void DunRand1PartSplit(bool isVert);


//----
EWRAM_CODE void DunRand1RoomMake();
EWRAM_CODE void DunRand1RoomConnect();
EWRAM_CODE s16  DunRand1RoomRandX(s16 idx);
EWRAM_CODE s16  DunRand1RoomRandY(s16 idx);


//----
EWRAM_CODE void DunRand1RoadMake(s16 roomA, s16 roomB);


//----
EWRAM_CODE void DunRand1MobMake(s16 floorCnt);
EWRAM_CODE void DunRand1MobMakeRand(s16 floorCnt);


//----
EWRAM_CODE void DunRand1FillRect(s16 left, s16 top, s16 right, s16 bottom, bool isWall);
EWRAM_CODE void DunRand1FillHLine(s16 left, s16 right, s16 y, bool isWall);
EWRAM_CODE void DunRand1FillVLine(s16 top, s16 bottom, s16 x, bool isWall);


#ifdef __cplusplus
}
#endif
#endif
