#ifndef __GAME_H__
#define __GAME_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"
#include "dun.h"
#include "mob.h"
#include "item.h"

//---------------------------------------------------------------------------
#define PARAM_MAX_CNT			5

enum {
	EXEC_ID_NONE = 0x00,
	EXEC_ID_MOVE,		// ړ
	EXEC_ID_EQUIP,		// ACȇ
	EXEC_ID_GET,		// ĂACeE
	EXEC_ID_DROP,		// ACêĂ
	EXEC_ID_USE,		// ACeg
	EXEC_ID_MAGIC,		// @̔΂肷
	EXEC_ID_ARROW,		// ̔΂肷
	EXEC_ID_PROVE,		// Ӓ肷ACeI
	EXEC_ID_STEP,		// KiړmF
	EXEC_ID_OVER,		// Q[I[o[
	EXEC_ID_LOAD,		// Z[u
	EXEC_ID_SAVE,		// [h
};


//---------------------------------------------------------------------------
typedef struct {
	u16  id;
	bool isHold;
	s16  param[PARAM_MAX_CNT];

	bool isOver;
	s16  floorCnt;
} ST_GAME;


//---------------------------------------------------------------------------
EWRAM_CODE void GameInit();
EWRAM_CODE bool GameLoad();
EWRAM_CODE void GameSave();
EWRAM_CODE void GameDraw();
EWRAM_CODE void GameTurn();

EWRAM_CODE void GameExec();
EWRAM_CODE void GameExecChk();
EWRAM_CODE void GameExecOver();
EWRAM_CODE void GameExecMove();
EWRAM_CODE void GameExecStep();
EWRAM_CODE void GameExecEquip();
EWRAM_CODE void GameExecGet();
EWRAM_CODE void GameExecDrop();
EWRAM_CODE void GameExecUse();
EWRAM_CODE void GameExecMagic();
EWRAM_CODE void GameExecArrow();
EWRAM_CODE void GameExecProve();
EWRAM_CODE void GameExecSave();
EWRAM_CODE bool GameExecLoad();


//----
EWRAM_CODE void GameActHeroAtk(ST_MOB_CHR* pMob);
EWRAM_CODE void GameActMobAtk(ST_MOB_CHR* pMob);
EWRAM_CODE void GameActNextFloor();
EWRAM_CODE void GameActTrap(ST_TILE* pTile);
EWRAM_CODE void GameActMagic(s16 num, u16 key);
EWRAM_CODE void GameActArrow(s16 num, u16 key);

EWRAM_CODE bool GameActUse(s16 cnt);
EWRAM_CODE bool GameActUseHP(ST_ITEM* pItem);
EWRAM_CODE bool GameActUseMP(ST_ITEM* pItem);
EWRAM_CODE bool GameActUsePoison(ST_ITEM* pItem);
EWRAM_CODE bool GameActUseFood(ST_ITEM* pItem);
EWRAM_CODE bool GameActUseWarp();
EWRAM_CODE bool GameActUseMagicRoom(ST_ITEM* pItem);


//----
EWRAM_CODE void GameSetExec(u16 id, bool isHold);
EWRAM_CODE bool GameIsOver();




#ifdef __cplusplus
}
#endif
#endif
