#include "hero.h"
#include "msg.h"
#include "bg.h"
#include "spr.h"

//---------------------------------------------------------------------------
// ole[u
static const s32 HeroExpDB[HERO_MAX_LV_CNT] = {
	5,					// 1 玟̃xɕKvȌol
	10,					// 2
	20,					// 3
	40,					// 4
	80,					// 5
	60,					// 6
	320,				// 7
	640,				// 8
	1300,				// 9
	2600,				// 10
	5200,				// 11
	10000,				// 12
	20000,				// 13
	39000,				// 14
	68000,				// 15
	100000,				// 16
	200000,				// 17
	400000,				// 18
	800000,				// 19
	1600000,			// 20
	2500000,			// 21
	4600000,			// 22
	6700000,			// 23
	8000000,			// 24
	HERO_MAX_EXP_CNT,	// 25(ŏIx̓JXgMAX_EXPɂ邱)
};

// fobOp̍ŋACe
static const ST_ITEM HeroDebugItemDB[] = {
	{ITEM_ID_USEITEM,	"",				"",		{USEITEM_ID_HPCURE,50,0,0},	FALSE},
	{ITEM_ID_USEITEM,	"悭",		"",		{USEITEM_ID_HPCURE,100,0,0},	FALSE},
	{ITEM_ID_USEITEM,	"",		"",		{USEITEM_ID_PROVE,0,0,0},	FALSE},
	{ITEM_ID_USEITEM,	"",		"",		{USEITEM_ID_PROVE,0,0,0},	FALSE},
	{ITEM_ID_USEITEM,	"p",				"",		{USEITEM_ID_FOOD,50,0,0},	FALSE},
	{ITEM_ID_USEITEM,	"ACLtC",	"",		{USEITEM_ID_WARP,0,0,0},	FALSE},
	{ITEM_ID_USEITEM,	"S̊",		"",		{USEITEM_ID_MAGIC,5,10,MAGIC_ID_ROOM},	FALSE},
	{ITEM_ID_USEITEM,	"PU",		"",		{USEITEM_ID_MAGIC,5,10,MAGIC_ID_ONCE},	FALSE},
	{ITEM_ID_USEITEM,	"ђʍU",		"",		{USEITEM_ID_MAGIC,5,10,MAGIC_ID_PENETRATE},	FALSE},
	{ITEM_ID_USEITEM,	"ŃACe",		"",		{USEITEM_ID_HPCURE,-HERO_MAX_HP_CNT,0,MAGIC_ID_PENETRATE},	FALSE},
	{ITEM_ID_RING,		"͂̎w",			"w",	{0,5,0,0},	FALSE},								//	17
	{ITEM_ID_RING,		"̎w",		"w",	{1,5,0,0},	FALSE},								//	18
	{ITEM_ID_WEAPON,	"悢",			"",	{10,0,0,0},	FALSE},								//	11
};

//---------------------------------------------------------------------------
ST_HERO Hero;


//---------------------------------------------------------------------------
EWRAM_CODE void HeroInit()
{
	_Memset(&Hero, 0x00, sizeof(ST_HERO));

	ST_HERO* p = &Hero;

	p->maxHp     = 10;
    p->maxMp     =  1;
	p->hp        = 10;
	p->mp        =  1;
	p->speed     = 10;
	p->poison    =  0;
	p->atk       =  1;
	p->def       =  1;
	p->agi       =  1;
	p->lv        =  1;
	p->exp       =  0;
	p->hunger    =  0;
	p->turn      =  0;

	p->weapon.id = ITEM_ID_NONE;
	p->armor.id  = ITEM_ID_NONE;
	p->ring.id   = ITEM_ID_NONE;

	p->dir.pat   = 21;
	p->dir.vec   = VEC_DOWN;

	s16 i;
	for(i=0; i<HERO_MAX_ITEM_CNT; i++)
	{
		p->item[i].id = ITEM_ID_NONE;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE bool HeroLoad()
{
	if(SramIsStr("CSTS") == FALSE)
	{
		return FALSE;
	}

	u16 size = SramRead16();
	u16 ver  = SramRead16();

	SramReadCopy((u8*)&Hero, size);

	return TRUE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroSave()
{
	u16 size = sizeof(ST_HERO);
	u16 ver  = 100;

	SramWriteCopy((u8*)"CSTS", 4);
	SramWrite16(size);
	SramWrite16(ver);

	SramWriteCopy((u8*)&Hero, size);
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroDraw()
{
	ST_HERO* p = &Hero;

	// Xe[^X
	s16 maxHp = HeroGetMaxHp();
	s16 hg    = HeroGetHangerPercent();

	char str[32];
	_Sprintf(str, "LV:%2d HP:%3d/%3d HANG:%3d\n", p->lv, maxHp, p->hp, hg);
	BgAsciiDrawStr(0,0,str);

	// XvCg
	u16 pat = DirChrGetPat(&p->dir);
	SprSetBuf(pat, 32*3+16, 32*2+16);
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroTurn()
{
	ST_HERO* p = &Hero;

	p->turn++;

	//
	if(p->poison != 0)
	{
		if(p->hp >= 2)
		{
			p->hp -= 1;
		}

		p->poison--;
		if(p->poison <= 0)
		{
			MsgAdd(MSG_ID_INFO, "łȂȂ悤" );
		}
	}
	else
	{
		// ł󂯂ĂȂ΁A10^[ɂPHP1񕜂܂
		if(DivMod(p->turn, 10) == 0)
		{
			HeroAddHp(1);
		}
	}

	//
	if(p->hunger >= HERO_MAX_HUNGER_CNT)
	{
		/* TODO fobOIO
		HeroAddHp(-1);

		if(HeroIsDead() == TRUE)
		{
			MsgAdd(MSG_ID_INFO, "쎀" );
		}
		*/
	}
	else
	{
		// 󕠂Ȃ̂ŁA1|Cg󕠂ɂȂ܂
		HeroAddEat(-1);
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroMove(s16 mx, s16 my)
{
	HeroDir(mx, my);

	Hero.x = mx;
	Hero.y = my;
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroDir(s16 mx, s16 my)
{
	Hero.dir.vec = DirChrGetVec(mx - Hero.x, my - Hero.y);
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroAddHp(s16 val)
{
	ST_HERO* p = &Hero;

	s16 old = p->hp;
	s16 max = HeroGetMaxHp();

	p->hp += val;

	if(max < p->hp)
	{
		p->hp = max;
	}
	else if(p->hp < 0)
	{
		p->hp = 0;
	}

	return p->hp - old;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroAddMp(s16 val)
{
	ST_HERO* p = &Hero;

	s16 old = p->mp;
	s16 max = HeroGetMaxMp();

	p->mp += val;

	if(max < p->mp)
	{
		p->mp = max;
	}
	else if(p->mp < 0)
	{
		p->mp = 0;
	}

	return p->mp - old;
}
//---------------------------------------------------------------------------
//value̒l : :󕠑
EWRAM_CODE void HeroAddEat(s16 val)
{
	ST_HERO* p = &Hero;
	s16 old = p->hunger;

	p->hunger -= val;

	if(p->hunger < 0)
	{
		p->hunger = 0;
	}
	else if(p->hunger > HERO_MAX_HUNGER_CNT)
	{
		p->hunger = HERO_MAX_HUNGER_CNT;
	}

	if(old < HERO_MAX_HUNGER_CNT && p->hunger == HERO_MAX_HUNGER_CNT)
	{
		MsgAdd(MSG_ID_INFO, "Ďɂ");
	}
	else if(old < HERO_HUNGER_WARNING_CNT && p->hunger >= HERO_HUNGER_WARNING_CNT)
	{
		MsgAdd(MSG_ID_INFO, "Ă" );
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroAddDmg(s16 dmg)
{
	if(dmg > 0)
	{
		Hero.hp -= dmg;

		if(Hero.hp <= 0)
		{
			Hero.hp = 0;
		}
	}

	return dmg;
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroAddExp(s32 exp)
{
	ST_HERO* p = &Hero;

	p->exp += exp;
	MsgAdd(MSG_ID_INFO, "ol%d𓾂", exp);

	if(p->exp > HERO_MAX_EXP_CNT)
	{
		p->exp = HERO_MAX_EXP_CNT;
	}

	if(HeroIsLvUp() == TRUE)
	{
		HeroSetLvUp();
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroAddPoison(s16 turn)
{
	ST_HERO* p = &Hero;
	s16 old = p->poison;

	// ł̗L^[Zbg܂
	p->poison = turn;

	// ȑO̒lԂ
	return old;
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroAddItem(ST_ITEM* pItem)
{
	if(HeroSetItem(pItem) == TRUE)
	{
		HeroSortItem();
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroDelItem(s16 num)
{
	if(num >= Hero.itemCnt)
	{
		SystemError("[Err] HeroDelItem num = %d\n", num);
	}

	Hero.item[num].id = ITEM_ID_NONE;
	HeroSortItem();
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroDelItem2(s16 cnt, u16 maskId)
{
	s16 sel = 0;
	s16 i;

	for(i=0; i<Hero.itemCnt; i++)
	{
		if(!(Hero.item[i].id & maskId))
		{
			continue;
		}

		if(sel != cnt)
		{
			sel++;
			continue;
		}

		if(sel >= Hero.itemCnt)
		{
			goto Err;
		}

		Hero.item[sel].id = ITEM_ID_NONE;
		HeroSortItem();
		return;
	}

Err:
	SystemError("[Err] HeroDelItem2 cnt = %d, maskId = %x\n", cnt, maskId);
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroSortItem()
{
	ST_ITEM tmp;
	s16 i, j;

	// TODO f[^\ƃ[`̉

	for(i=0; i<HERO_MAX_ITEM_CNT-1; i++)
	{
		for(j=HERO_MAX_ITEM_CNT-1; j>i; j--)
		{
			if(Hero.item[j].id < Hero.item[j-1].id)
			{
				ItemCopy(&tmp, &Hero.item[j]);
				ItemCopy(&Hero.item[j], &Hero.item[j-1]);
				ItemCopy(&Hero.item[j-1], &tmp);
			}
		}
	}

	Hero.itemCnt = 0;
	for(i=0; i<HERO_MAX_ITEM_CNT; i++)
	{
		if(Hero.item[i].id != ITEM_ID_NONE)
		{
			Hero.itemCnt++;
		}
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetX()
{
	return Hero.x;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetY()
{
	return Hero.y;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetHp()
{
	return Hero.hp;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetMaxHp()
{
	ST_HERO* p = &Hero;
	s16 hp = p->maxHp;

	if(p->ring.id == ITEM_ID_RING && p->ring.param[0] == 2)
	{
		hp += p->ring.param[1];
	}

	return hp;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetMaxMp()
{
	ST_HERO* p = &Hero;
	s16 mp = p->maxMp;

	if(p->ring.id == ITEM_ID_RING && p->ring.param[0] == 3)
	{
		mp += p->ring.param[1];
	}

	return mp;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetAtk()
{
	ST_HERO* p = &Hero;
	s16 atk = p->atk;

	if(p->weapon.id != ITEM_ID_NONE)
	{
		atk += p->weapon.param[0];
	}

	if(p->ring.id == ITEM_ID_RING && p->ring.param[0] == 0)
	{
		atk += p->ring.param[1];
	}

	return atk;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetAtkMagic(ST_ITEM* pItem)
{
	return pItem->param[2];
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetAtkArrow(ST_ITEM* pItem)
{
	return pItem->param[1];
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetDef()
{
	ST_HERO* p = &Hero;
	s16 def = p->def;

	if(p->armor.id != ITEM_ID_NONE)
	{
		def += p->armor.param[0];
	}

	if(p->ring.id == ITEM_ID_RING && p->ring.param[0] == 1)
	{
		def += p->ring.param[1];
	}

	return def;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetAgi()
{
	ST_HERO* p = &Hero;
	s16 agi = p->agi;

	return agi;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetExpLv()
{
	ST_HERO* p = &Hero;
	s16 lv;

	for(lv=0; lv<HERO_MAX_LV_CNT; lv++)
	{
 		if(HeroExpDB[lv] > p->exp)
 		{
			break;
		}
 	}

	return lv+1;
}
//---------------------------------------------------------------------------
// nw 0-100% ŕԂ܂(؂グ)
EWRAM_CODE s16 HeroGetHangerPercent()
{
	return Div(Hero.hunger * 100, HERO_MAX_HUNGER_CNT);
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetSpeed()
{
	return Hero.speed;
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroSetLvUp()
{
	ST_HERO* p = &Hero;

	// xŉ񃌃xAbvmF܂
	s16 newLv = HeroGetExpLv();

	while(p->lv < newLv)
	{
		p->lv++;
		MsgAdd(MSG_ID_INFO, "x%dɂȂI", p->lv);

		s16 hp  = _Rand(8) + 3;		// R`PO
		s16 atk = _Rand(3) + 3;		// R`T
		s16 def = 8 - atk;			// U͂̔ő₵܂
		s16 agi = _Rand(2) + 1;		// P`Q

		p->maxHp += hp;
		p->atk   += atk;
		p->def   += def;
		p->agi   += agi;

		if(p->maxHp > HERO_MAX_HP_CNT)
		{
			p->maxHp = HERO_MAX_HP_CNT;
		}
		HeroAddHp(HERO_MAX_HP_CNT);

//		MsgAdd(MSG_ID_INFO, "MaxHP  %d I  ̗͂SI", hp);
//		MsgAdd(MSG_ID_INFO, "ATK  %d I  DEF  %d I  AGI  %d I", atk, def, agi);
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroSetXY(s16 x, s16 y)
{
	ST_HERO* p = &Hero;

	p->x       = x;
	p->y       = y;
	p->dir.vec = VEC_DOWN;
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroSetEquip(ST_ITEM* pSrc)
{
	ST_HERO* h = &Hero;
	ST_ITEM* pDst;
	ST_ITEM  tmp;

	switch(pSrc->id)
	{
	case ITEM_ID_WEAPON:
		pDst = &h->weapon;
		break;

	case ITEM_ID_ARMOR:
		pDst = &h->armor;
		break;

	case ITEM_ID_RING:
		pDst = &h->ring;
		break;

	default:
		return;
	}

	ItemCopy(&tmp, pDst);
	ItemCopy(pDst, pSrc);
	ItemCopy(pSrc, &tmp);
	HeroSortItem();

	// ȑȎɂđĂHP/MPA
	// ̑ɂőȏɂȂȂ悤ɒ܂
	s16 maxHp = HeroGetMaxHp();
	s16 maxMp = HeroGetMaxMp();
	if(h->hp > maxHp)
	{
		h->hp = maxHp;
	}
	if(h->mp > maxMp)
	{
		h->mp = maxMp;
	}
}
//---------------------------------------------------------------------------
// OďoɂHeroAddItemgpĂ
EWRAM_CODE bool HeroSetItem(ST_ITEM* pSrc)
{
	ST_HERO* p = &Hero;
	s16 i;

	if(ItemIsArrow(pSrc) == TRUE)
	{
		for(i=0; i<Hero.itemCnt; i++)
		{
			// łAU͂`FbN܂
			ST_ITEM* pSlot = &p->item[i];
			if(ItemIsArrow(pSlot) == FALSE || pSlot->param[1] != pSrc->param[1])
			{
				continue;
			}

			// 𑩂˂܂
			pSlot->param[2] += pSrc->param[2];
			if(pSlot->param[2] > ITEM_MAX_ARROW_CNT)
			{
				pSlot->param[2] = ITEM_MAX_ARROW_CNT;
			}

			// łɊӒς݂̂E΁AĂ̂Ӓς݂
			if(pSrc->isUnidentified == FALSE)
			{
				pSlot->isUnidentified = FALSE;
			}

			return TRUE;
		}
	}


	for(i=0; i<HERO_MAX_ITEM_CNT; i++)
	{
		if(p->item[i].id == ITEM_ID_NONE)
		{
			ItemCopy(&p->item[i], pSrc);
			return TRUE;
		}
	}

	return FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroSetNextFloor()
{
	Hero.turn = 0;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetItemCnt()
{
	return Hero.itemCnt;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 HeroGetItemCnt2(u16 maskId)
{
	s16 cnt = 0;
	s16 i;

	for(i=0; i<Hero.itemCnt; i++)
	{
		if(Hero.item[i].id & maskId)
		{
			cnt++;
		}
	}

	return cnt;
}
//---------------------------------------------------------------------------
EWRAM_CODE char* HeroGetItemStr(u16 cnt)
{
	return ItemGetName(&Hero.item[cnt]);
}
//---------------------------------------------------------------------------
EWRAM_CODE char* HeroGetItemStr2(u16 cnt, u16 maskId)
{
	s16 sel = 0;
	s16 i;

	for(i=0; i<Hero.itemCnt; i++)
	{
		if(Hero.item[i].id & maskId)
		{
			if(sel != cnt)
			{
				sel++;
				continue;
			}

			return ItemGetName(&Hero.item[cnt]);
		}
	}

	return NULL;
}
//---------------------------------------------------------------------------
EWRAM_CODE ST_ITEM* HeroGetItem(u16 cnt)
{
	return &Hero.item[cnt];
}
//---------------------------------------------------------------------------
EWRAM_CODE ST_ITEM* HeroGetItem2(u16 cnt, u16 maskId)
{
	s16 sel = 0;
	s16 i;

	for(i=0; i<Hero.itemCnt; i++)
	{
		if(Hero.item[i].id & maskId)
		{
			if(sel != cnt)
			{
				sel++;
				continue;
			}

			return &Hero.item[cnt];
		}
	}

	return NULL;
}
//---------------------------------------------------------------------------
EWRAM_CODE bool HeroIsLvUp()
{
	return (HeroExpDB[Hero.lv - 1] <= Hero.exp) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE bool HeroIsDead()
{
	return (Hero.hp <= 0) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE bool HeroIsItemFull()
{
	return (Hero.itemCnt >= HERO_MAX_ITEM_CNT) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void HeroDebugAddItem()
{
	s16 i;

	for(i=0; i<(s16)sizeof(HeroDebugItemDB); i++)
	{
		HeroAddItem((ST_ITEM*)&HeroDebugItemDB[i]);
	}
}
