#ifndef __HERO_H__
#define __HERO_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"
#include "item.h"
#include "dir.h"

//---------------------------------------------------------------------------
#define HERO_MAX_LV_CNT			25		// vC[̍ő僌x
#define HERO_MAX_EXP_CNT		9999999	// ol̃JXgl
#define HERO_MAX_ITEM_CNT		20		// ĂACe̍ő吔
#define HERO_MAX_HP_CNT			999		// HP̃JXgl
#define HERO_MAX_MP_CNT			999		// MP̃JXgl

#define HERO_MAX_HUNGER_CNT		500		// Sɋ󕠂ɂȂ
#define HERO_HUNGER_WARNING_CNT	450		// 󕠂ɂȂĂx


//---------------------------------------------------------------------------
typedef struct {
	s16 x;								// ݈ʒu
	s16 y;
	s16 lv;								// x
	s32 exp;							// ol
	s16 maxHp;							// ő̗
	s16 maxMp;							// őMP
	s16 hp;								// ̗
	s16 mp;								// MP
	s16 poison;							// ł̎cL^[
	s16 hunger;							// 󕠓x(0:-MAX_HUNGER:)
	s16 turn;							// ^[JEg
	s16 speed;							// Ps̕KvTCN

	s16 atk;							// U
	s16 def;							// h
	s16 agi;							// 

	ST_ITEM item[HERO_MAX_ITEM_CNT];	// ACe
	s16 itemCnt;

	ST_ITEM weapon;						// 
	ST_ITEM armor;						// h
	ST_ITEM ring;						// w

	ST_DIR_CHR dir;						// OtBbNƕ
} ST_HERO;


//---------------------------------------------------------------------------
EWRAM_CODE void  HeroInit();
EWRAM_CODE bool  HeroLoad();
EWRAM_CODE void  HeroSave();
EWRAM_CODE void  HeroTurn();
EWRAM_CODE void  HeroDraw();
EWRAM_CODE void  HeroMove(s16 mx, s16 my);
EWRAM_CODE void  HeroDir(s16 mx, s16 my);


EWRAM_CODE s16   HeroAddHp(s16 val);
EWRAM_CODE s16   HeroAddMp(s16 val);
EWRAM_CODE void  HeroAddEat(s16 value);
EWRAM_CODE s16   HeroAddDmg(s16 dmg);
EWRAM_CODE void  HeroAddExp(s32 exp);
EWRAM_CODE s16   HeroAddPoison(s16 turn);
EWRAM_CODE void  HeroAddItem(ST_ITEM* pItem);

EWRAM_CODE void  HeroDelItem(s16 num);
EWRAM_CODE void  HeroDelItem2(s16 cnt, u16 maskId);
EWRAM_CODE void  HeroSortItem();

EWRAM_CODE s16   HeroGetX();
EWRAM_CODE s16   HeroGetY();
EWRAM_CODE s16   HeroGetHp();
EWRAM_CODE s16   HeroGetMaxHp();
EWRAM_CODE s16   HeroGetMaxMp();
EWRAM_CODE s16   HeroGetAtk();
EWRAM_CODE s16   HeroGetAtkMagic(ST_ITEM* pItem);
EWRAM_CODE s16   HeroGetAtkArrow(ST_ITEM* pItem);
EWRAM_CODE s16   HeroGetDef();
EWRAM_CODE s16   HeroGetAgi();
EWRAM_CODE s16   HeroGetExpLv();
EWRAM_CODE s16   HeroGetHangerPercent();
EWRAM_CODE s16   HeroGetSpeed();

EWRAM_CODE void  HeroSetLvUp();
EWRAM_CODE void  HeroSetXY(s16 x, s16 y);
EWRAM_CODE void  HeroSetEquip(ST_ITEM* pSrc);
EWRAM_CODE bool  HeroSetItem(ST_ITEM* pSrc);		// ďoɂHeroAddItemgp邱
EWRAM_CODE void  HeroSetNextFloor();

EWRAM_CODE s16   HeroGetItemCnt();
EWRAM_CODE s16   HeroGetItemCnt2(u16 maskId);
EWRAM_CODE char* HeroGetItemStr(u16 cnt);
EWRAM_CODE char* HeroGetItemStr2(u16 cnt, u16 maskId);
EWRAM_CODE ST_ITEM* HeroGetItem(u16 cnt);
EWRAM_CODE ST_ITEM* HeroGetItem2(u16 cnt, u16 maskId);

EWRAM_CODE bool  HeroIsLvUp();
EWRAM_CODE bool  HeroIsDead();
EWRAM_CODE bool  HeroIsMove(s16 mx, s16 my);
EWRAM_CODE bool  HeroIsItemFull();

EWRAM_CODE void  HeroDebugAddItem();

#ifdef __cplusplus
}
#endif
#endif
