#ifndef __INTR_H__
#define __INTR_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "lib/gba.h"

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
typedef struct {
	void* handler[MAX_INTS];
} ST_INTR_TABLE;


//---------------------------------------------------------------------------
EWRAM_CODE void IntrInit();
IWRAM_CODE void IntrMain();
IWRAM_CODE void IntrDummy();

EWRAM_CODE void IntrStart();
EWRAM_CODE void IntrStop();
EWRAM_CODE void IntrEnable(irqMASK mask);
EWRAM_CODE void IntrDisable(irqMASK mask);

EWRAM_CODE void IntrSetHandler(irqMASK num, void* function);
EWRAM_CODE void IntrUnSetHandler(irqMASK num);



//----
IWRAM_CODE void IntrVcount();
IWRAM_CODE void IntrVblank();


#ifdef __cplusplus
}
#endif
#endif
