#ifndef _GAMEMATH_H
#define _GAMEMATH_H
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

#include "gba.h"

#define INT2FIX(A) ((A)<<7)
#define FIX2INT(A) ((A)>>7)

//==============================================================
// Z
// 鐔m 0 <= D < 256 ƕĂȂFIXDIV
// 16bitŕtSFIXDIV
// 16bitŕUFIXDIV
//==============================================================
#define FIXMUL(A,B) ( ((A)*(B))>>14 )
#define FIXDIV(A,B) ( (((A)*fixdivTable[(B)])>>15)&0xffff )
extern const u16 fixdivTable[];

IWRAM_CODE u32 UFIXDIV(u32 a, u16 b);
IWRAM_CODE s32 SFIXDIV(s32 a, s16 b);

//==============================================================
// Op֐
//==============================================================
#define SIN(deg)	(sinTable[(deg) & 255])
#define COS(deg)	(sinTable[((deg)+64) & 255])
#define SIN2(deg)	(sinTable[(deg) & 255] * 2)
#define COS2(deg)	(sinTable[((deg)+64) & 255] * 2)
extern const s8 sinTable[];

//==============================================================
// t
//==============================================================
IWRAM_CODE u16 ATAN2(s16 xx, s16 yy);




#ifdef __cplusplus
}
#endif // __cplusplus

#endif // _GAMEMATH_H
