#include "common.h"
#include "mymem.h"


//---------------------------------------------------------------------------
ST_MYMEM MyMem EWRAM_BSS;

// lib/common.c
extern u32 dummy;

//---------------------------------------------------------------------------
EWRAM_CODE void MyMemInit()
{
	_Memset((u8*)&MyMem, 0x00, sizeof(ST_MYMEM));
	MyMemFree((u32)&MyMem.ram[0], MYMEM_SIZE);
}
//---------------------------------------------------------------------------
IWRAM_CODE bool MyMemFree(u32 addr, u32 size)
{
	ST_MYMEM* p = &MyMem;
	u16 i, j;

	size += 3;
	size &= 0xfffffffc;

	//TRACEOUT("MyMemFree addr=0x%x size=%d\n", addr, size);

	// free[]addrɕׁׂAfree[]̑}ꏊ߂܂
	for(i=0; i<p->cnt; i++)
	{
		if(p->info[i].addr > addr)
		{
			break;
		}
	}

	// Ő󂫗̈悪邩`FbN܂
	if((i > 0) && (p->info[i-1].addr + p->info[i-1].size == addr))
	{
		p->info[i-1].size += size;

		// ̋󂫗̈悪邩`FbN܂
		if((i < p->cnt) && (addr + size == p->info[i].addr))
		{
			p->info[i-1].size += p->info[i].size;
			p->cnt--;

			// free[i]ȂȂ̂őO֋l߂܂
			while(i < p->cnt)
			{
				p->info[i] = p->info[i + 1];
				i++;
			}
		}

		return TRUE;
	}

	// Ő󂫗̈Ƃ܂Ƃ߂ȂꍇA낪邩`FbN܂
	if((i < p->cnt) && (addr + size == p->info[i].addr))
	{
		p->info[i].addr  = addr;
		p->info[i].size += size;

		return TRUE;
	}

	// Oɂ̗̈ɂ܂Ƃ߂ȂꍇAfree[i]ɂ炵ČԂ܂
	if(p->cnt < MYMEM_MAX_INFO_CNT)
	{
		for(j=p->cnt; j>i; j--)
		{
			p->info[j] = p->info[j-1];
		}
		p->cnt++;

		p->info[i].addr = addr;
		p->info[i].size = size;

		return TRUE;
	}

	SystemError("MyMemFree Error\n");
	return FALSE;
}
//---------------------------------------------------------------------------
IWRAM_CODE void* MyMemMalloc(u32 size)
{
	ST_MYMEM* p = &MyMem;
	u8* addr;
	u16 i;

	// u32PʂŐ؂蕪܂
	size += 3;
	size &= 0xfffffffc;

	for(i=0; i<p->cnt; i++)
	{
		if(p->info[i].size < size)
		{
			continue;
		}

		addr = (u8*)p->info[i].addr;

		p->info[i].addr += size;
		p->info[i].size -= size;

		if(p->info[i].size == 0)
		{
			p->cnt--;

			// free[i]ȂȂ̂őO֋l߂܂
			while(i < p->cnt)
			{
				p->info[i] = p->info[i + 1];
				i++;
			}
		}

		//TRACEOUT("MyMemAlloc addr=0x%x size=%d\n", addr, size);
		return addr;
	}

	SystemError("[Err] MyMemAlloc size=%d\n", size);
	return NULL;
}
//---------------------------------------------------------------------------
IWRAM_CODE void* MyMemCalloc(u32 size)
{
	size += 3;
	size &= 0xfffffffc;

	void* p = MyMemMalloc(size);

	REG_DMA3SAD = (u32)&dummy;
	REG_DMA3DAD = (u32)p;
	REG_DMA3CNT = (u32)(size / 2) | (DMA_SRC_FIXED | DMA_DST_INC | DMA16 | DMA_ENABLE);

//	_Memset(p, 0x00, size);

	return p;
}
//---------------------------------------------------------------------------
EWRAM_CODE u32 MyMemGetFreeSize()
{
	ST_MYMEM* p = &MyMem;

	u32 freeSize = 0;
	u16 i;

	for(i=0; i<p->cnt; i++)
	{
		freeSize += p->info[i].size;
	}

	return freeSize;
}
