#ifndef __MOB_H__
#define __MOB_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"
#include "dir.h"

//---------------------------------------------------------------------------
#define MAX_MOB_CNT				(50+1)		//X^[̍ő吔iMAX_CHR_CNTƘAj
#define MAX_MOB_NAME_CNT		20


//---------------------------------------------------------------------------

typedef struct {
	char  name[MAX_MOB_NAME_CNT];
	u16   firstFloorCnt;
	u16   lastFloorCnt;
	u16   ai;
	s16   exp;
	s16   agi;
	s16   atk;
	s16   def;
	s16   speed;
	s16   hp;
	s16   graphic;
	s16   dropItemID;
	s16   dropPercent;
	s16   dropUnidentified;
} ST_MOB_DB;

typedef struct {
	char name[MAX_MOB_NAME_CNT];
	u16 ai;
	s16 exp;
	s16 agi;
	s16 atk;
	s16 def;
	s16 speed;
	s16 hp;
	s16 maxHp;
	s16 dropItemID;
	s16 dropPercent;
	s16 dropUnidentified;

	u16  x;
	u16  y;
	bool isUnidentified;
	s16  tickCnt;
	ST_DIR_CHR dir;
} ST_MOB_CHR;

typedef struct {
	u16 cnt;
	ST_MOB_CHR chr[MAX_MOB_CNT];
} ST_MOB;

//---------------------------------------------------------------------------
EWRAM_CODE void MobInit();
EWRAM_CODE bool MobLoad();
EWRAM_CODE void MobSave();
EWRAM_CODE void MobTurn();
EWRAM_CODE void MobDraw();
EWRAM_CODE void MobSort();
EWRAM_CODE void MobCopy(ST_MOB_CHR* pDst, ST_MOB_CHR* pSrc);


EWRAM_CODE ST_MOB_CHR* MobMake();
EWRAM_CODE ST_MOB_CHR* MobMakeRnd(s16 x, s16 y, s16 floorCnt);
EWRAM_CODE ST_MOB_CHR* MobGetChr(s16 x, s16 y);
EWRAM_CODE ST_MOB_CHR* MobGetChr2(s16 num);

EWRAM_CODE s16  MobGetCnt();
EWRAM_CODE s16  MobGetAtk(ST_MOB_CHR* pMob);
EWRAM_CODE s16  MobAddDmg(ST_MOB_CHR* pMob, s16 dmg);

EWRAM_CODE bool MobIsMaxCnt();
EWRAM_CODE bool MobIsDead(ST_MOB_CHR* pMob);


//----
EWRAM_CODE void MobMove();
EWRAM_CODE void MobMoveChr1(ST_MOB_CHR* pMob);
EWRAM_CODE void MobMoveChr2(ST_MOB_CHR* pMob);
EWRAM_CODE void MobMoveChr3(ST_MOB_CHR* pMob);
EWRAM_CODE void MobMoveChr4(ST_MOB_CHR* pMob);
EWRAM_CODE void MobMoveAct(ST_MOB_CHR* pMob, s16 mx, s16 my);
EWRAM_CODE void MobMoveTest(s16* px, s16* py, bool isToBig);
EWRAM_CODE bool MobMoveIsComp(s16 a, s16 b, bool toBig);


//----
EWRAM_CODE void MobDebug();




#ifdef __cplusplus
}
#endif
#endif
