#include "mobmap.h"
#include "dun.h"
#include "hero.h"

//---------------------------------------------------------------------------
ST_MOB_MAP MobMap;


//---------------------------------------------------------------------------
EWRAM_CODE void MobMapCalloc()
{
	if(MobMap.pData != NULL)
	{
		MobMapFree();
	}

	ST_MOB_MAP* p = &MobMap;

	p->cx    = DunGetCx();
	p->cy    = DunGetCy();
	p->pData = MyMemCalloc(p->cx * p->cy * sizeof(ST_MOB_MAP_DATA));

	MobMapMake();
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobMapFree()
{
	ST_MOB_MAP* p = &MobMap;
	MyMemFree((u32)p->pData, p->cx * p->cy * sizeof(ST_MOB_MAP_DATA));
}
//---------------------------------------------------------------------------
IWRAM_CODE void MobMapMake()
{
	const s16 vec[4][2]={ {0,-1}, {-1,0}, {1,0}, {0,1} };

	ST_MOB_MAP_DATA* pData = MobMap.pData;

	s16 sx = HeroGetX();
	s16 sy = HeroGetY();
	s16 ex = sx;
	s16 ey = sy;
	pData[sy*MobMap.cx + sx].cnt = 1;

	s16 i;
	s16 x, y;
	bool writeFlag = TRUE;

	// TODO 

Restart:

	writeFlag = FALSE;

	for(y=sy; y<=ey; y++)
	{
		for(x=sx; x<=ex; x++)
		{
			// `FbN
			if(pData[y*MobMap.cx + x].cnt == 0)
			{
				continue;
			}

			// ς݃`FbN
			if(pData[y*MobMap.cx + x].isChk == TRUE)
			{
				continue;
			}
			pData[y*MobMap.cx + x].isChk = TRUE;

			for(i=0; i<4; i++)
			{
				s16 hx  = x + vec[i][0];
				s16 hy  = y + vec[i][1];

				// ǃ`FbN
				ST_TILE* pTile = DunGetTile(hx, hy);
				if(pTile->isWall == TRUE)
				{
					continue;
				}

				// l`FbN
				s16* pSrc = &pData[ y*MobMap.cx +  x].cnt;
				s16* pDst = &pData[hy*MobMap.cx + hx].cnt;

				if(*pDst != 0 || *pSrc <= *pDst)
				{
					continue;
				}

				// ͈̔̓`FbN
				if(hx < sx) sx = hx;
				if(hx > ex) ex = hx;
				if(hy < sy) sy = hy;
				if(hy > ey) ey = hy;

				*pDst = *pSrc + 1;
				writeFlag = TRUE;
			}
		}
	}

	if(writeFlag == TRUE)
	{
		goto Restart;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 MobMapGetVal(s16 sx, s16 sy)
{
	return MobMap.pData[sy*MobMap.cx + sx].cnt;
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobMapDebug()
{
	s16 x, y;

	TRACEOUT("--MobMapDebug Start--\n");

	for(y=0; y<MobMap.cy; y++)
	{
		for(x=0; x<MobMap.cx; x++)
		{
			TRACEOUT("%3d,", MobMap.pData[y*MobMap.cx + x].cnt);
		}
		TRACEOUT("\n");
	}

	TRACEOUT("--MobMapDebug End--\n");
}
