#include "msg.h"
#include "bg.h"

//---------------------------------------------------------------------------
ST_MSG Msg;
ST_SEL Sel;


//---------------------------------------------------------------------------
EWRAM_CODE void MsgInit()
{
	_Memset(&Msg, 0x00, sizeof(ST_MSG));
}
//---------------------------------------------------------------------------
EWRAM_CODE void MsgAdd(u16 id, char* format, ...)
{
	char buf[80] ALIGN(4);

	va_list ap;
	va_start(ap, format);
	_DoSprintf(buf, format, ap);
	va_end(ap);

	Msg.cnt++;

	if(Msg.cnt >= MSG_MAX_CNT)
	{
		Msg.cnt = 0;
	}

	Msg.data[Msg.cnt].id = id;
	_Strncpy(Msg.data[Msg.cnt].str, buf, MSG_MAX_LEN);

	Msg.isDraw = TRUE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void MsgDraw()
{
	// TODO
	BgSjisDrawStr(0, 9, "@@@@@@@@@@@@@@@@@@@@");
	BgSjisDrawStr(0, 9, Msg.data[Msg.cnt].str);

	u16 cnt = (Msg.cnt == 0) ? MSG_MAX_CNT - 1 : Msg.cnt - 1;

	BgSjisDrawStr(0, 8, "@@@@@@@@@@@@@@@@@@@@");
	BgSjisDrawStr(0, 8, Msg.data[cnt].str);
}
//---------------------------------------------------------------------------
EWRAM_CODE void MsgHide()
{
	Msg.isDraw = FALSE;
}




//---------------------------------------------------------------------------
EWRAM_CODE void SelInit()
{
	_Memset(&Sel, 0x00, sizeof(ST_SEL));
}
//---------------------------------------------------------------------------
EWRAM_CODE void SelAdd(char* format, ...)
{
	char buf[80] ALIGN(4);

	va_list ap;
	va_start(ap, format);
	_DoSprintf(buf, format, ap);
	va_end(ap);

	_Strncpy(Sel.str, buf, MSG_MAX_LEN);

	Sel.isDraw = TRUE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void SelDraw()
{
	if(Sel.isDraw == TRUE)
	{
		BgSjisDrawStr(0, 8, Sel.str);
	}
	else
	{
		// TODO
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void SelHide()
{
	Sel.isDraw = FALSE;
}
