#include "pcg.h"
#include "dma_arm.h"
#include "res.h"


//---------------------------------------------------------------------------
ST_PCG Pcg;

// lib/common.c
extern u32 dummy;

//---------------------------------------------------------------------------
EWRAM_CODE void PcgInit()
{
	_Memset(&Pcg, 0x00, sizeof(ST_PCG));

	Pcg.pTile = (ST_TILE_BLOCK*)GBFSGetSafePointer("spr.img");
}
//---------------------------------------------------------------------------
IWRAM_CODE void PcgClean()
{
	REG_DMA3SAD = (u32)&dummy;
	REG_DMA3DAD = (u32)&Pcg.blkCnt[0];
	REG_DMA3CNT = (u32)MAX_BLOCK_CNT | (DMA_SRC_FIXED | DMA_DST_INC | DMA16 | DMA_ENABLE);
}
//---------------------------------------------------------------------------
IWRAM_CODE u16 PcgGetOamTile(u16 pat)
{
	u16 blk = Pcg.bufPat[pat];

	// LbṼ`FbN܂
	if(blk == 0 || (pat != Pcg.blkPat[blk]))
	{
		//ȂꍇAo^pubNƃ^Cf[^̓]s܂
		blk = PcgGetBlockNum();
		PcgSetOamData(pat, blk);
	}
	else
	{
		// o^CNg܂
		Pcg.blkCnt[blk]++;
	}

	return blk * 8;
}
//---------------------------------------------------------------------------
IWRAM_CODE s16 PcgGetBlockNum()
{
	u16 num = Pcg.blkLastChkNum + 1;
	u16 tmp = num;

	// next-fit
	while(num < MAX_BLOCK_CNT)
	{
		if(Pcg.blkCnt[num] == 0)
		{
			goto fit;
		}
		num++;
	}

	// first-fit
	num = 1;
	while(num < tmp)
	{
		if(Pcg.blkCnt[num] == 0)
		{
			goto fit;
		}
		num++;
	}

	// 󂫃ubNȂ
	return 0;

fit:
	Pcg.blkLastChkNum = num;
	return num;
}
//---------------------------------------------------------------------------
IWRAM_CODE void PcgSetOamData(u16 pat, s16 blk)
{
	if(blk == 0)
	{
		SystemError("[Err] PcgSetOamData");
		return;
	}

	ST_TILE_BLOCK* oam = (ST_TILE_BLOCK*)OBJ_BASE_ADR;
	DmaEnqueue((u32*)&Pcg.pTile[pat].tile[0], (u32*)&oam[blk].tile[0], sizeof(ST_TILE_BLOCK) / 2);

	Pcg.blkCnt[blk] = 1;
	Pcg.blkPat[blk] = pat;
	Pcg.bufPat[pat] = blk;
}
