#include "spr.h"
#include "spranime.h"
#include "pcg.h"
#include "dma_arm.h"

//---------------------------------------------------------------------------
ST_SPR Spr;


// spranime.c
extern ST_SPR_ANIME SprAnimeChr;

// lib/common.c
extern u32 dummy;

//---------------------------------------------------------------------------
EWRAM_CODE void SprInit()
{
	_Memset(&Spr, 0x00, sizeof(ST_SPR));

	SprInitDat();
	SprInitPal();

	REG_DISPCNT |= (OBJ_ON | OBJ_1D_MAP);
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprInitDat()
{
	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprInitPal()
{
	u16* pPal = GBFSGetSafePointer("spr.pal");
	u16  i;

	for(i=0; i<256; i++)
	{
		OBJ_COLORS[i] = pPal[i];
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprClean()
{
	Spr.cnt = 0;

	REG_DMA3SAD = (u32)&dummy;
	REG_DMA3DAD = (u32)OAM;
	REG_DMA3CNT = (u32)sizeof(ST_SPRITE) * 128 / 2 | (DMA_SRC_FIXED | DMA_DST_INC | DMA16 | DMA_ENABLE);
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprSetBuf(u16 pat, s32 x, s32 y)
{
	ST_SPR_PAT* pPat = &SprAnimeChr.p[0];
	u16 num = SprAnimeChr.regCnt;
	u16 i;

	for(i=0; i<num; i++)
	{
		// y
		s32 yy = y + pPat->cy + 4;		// +4͉摜̕ϊs̕␳l
		if(yy >= 160 || yy <= -16)
		{
			pPat++;
			continue;
		}

		// x
		s32 xx = x + pPat->cx + 4;
		if(xx > 240 || xx <= -16)
		{
			pPat++;
			continue;
		}

		ST_SPRITE* pSpr = (ST_SPRITE*)OAM + Spr.cnt;

		pSpr->attr0 = (yy & 0x00ff) | ATTR0_COLOR_256 | ATTR0_NORMAL;
		pSpr->attr1 = (xx & 0x01ff) | pPat->flip | ATTR1_SIZE_16;
		pSpr->attr2 = PcgGetOamTile(pat + pPat->idx) | ATTR2_PRIORITY(1);

		Spr.cnt++;
		pPat++;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprSetVerti(s16 ofsY)
{
	Spr.ofsY = ofsY;
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprSetHoriz(s16 ofsX)
{
	Spr.ofsX = ofsX;
}
